Loading...
Searching...
No Matches
juce::ResamplingAudioSource Class Reference

`#include <juce_ResamplingAudioSource.h>`

Inheritance diagram for juce::ResamplingAudioSource:

## Public Member Functions

| ResamplingAudioSource (AudioSource *inputSource, bool deleteInputWhenDeleted, int numChannels=2)
| ~ResamplingAudioSource () override
void | setResamplingRatio (double samplesInPerOutputSample)
double | getResamplingRatio () const noexcept
void | flushBuffers ()
void | prepareToPlay (int samplesPerBlockExpected, double sampleRate) override
void | releaseResources () override
void | getNextAudioBlock (const AudioSourceChannelInfo &) override
Public Member Functions inherited from juce::AudioSource
virtual | ~AudioSource ()=default

## Additional Inherited Members

Protected Member Functions inherited from juce::AudioSource
| AudioSource ()=default

## Detailed Description

A type of AudioSource that takes an input source and changes its sample rate.

See also
  AudioSource, LagrangeInterpolator, CatmullRomInterpolator

Definition at line 34 of file juce_ResamplingAudioSource.h.

## Constructor & Destructor Documentation

## ResamplingAudioSource()

juce::ResamplingAudioSource::ResamplingAudioSource | ( | AudioSource * | inputSource,
|  | bool | deleteInputWhenDeleted,
|  | int | numChannels = 2 )

Creates a ResamplingAudioSource for a given input source.

Parameters

  inputSource | the input source to read from
  deleteInputWhenDeleted | if true, the input source will be deleted when this object is deleted
  numChannels | the number of channels to process

Definition at line 26 of file juce_ResamplingAudioSource.cpp.

## ~ResamplingAudioSource()

juce::ResamplingAudioSource::~ResamplingAudioSource | ( |  | ) |

override

Destructor.

Definition at line 36 of file juce_ResamplingAudioSource.cpp.

## Member Function Documentation

## flushBuffers()

void juce::ResamplingAudioSource::flushBuffers | ( |  | ) |

Clears any buffers and filters that the resampler is using.

Definition at line 63 of file juce_ResamplingAudioSource.cpp.

Referenced by prepareToPlay().

## getNextAudioBlock()

void juce::ResamplingAudioSource::getNextAudioBlock | ( | const AudioSourceChannelInfo & | bufferToFill | ) |

override virtual

Called repeatedly to fetch subsequent blocks of audio data.

After calling the prepareToPlay() method, this callback will be made each time the audio playback hardware (or whatever other destination the audio data is going to) needs another block of data.

It will generally be called on a high-priority system thread, or possibly even an interrupt, so be careful not to do too much work here, as that will cause audio glitches!

See also
  AudioSourceChannelInfo, prepareToPlay, releaseResources

Implements juce::AudioSource.

Definition at line 80 of file juce_ResamplingAudioSource.cpp.

## getResamplingRatio()

double juce::ResamplingAudioSource::getResamplingRatio | ( |  | ) | const

inline noexcept

Returns the current resampling ratio.

This is the value that was set by setResamplingRatio().

Definition at line 66 of file juce_ResamplingAudioSource.h.

## prepareToPlay()

void juce::ResamplingAudioSource::prepareToPlay | ( | int | samplesPerBlockExpected,
|  | double | sampleRate )

override virtual

Tells the source to prepare for playing.

An AudioSource has two states: prepared and unprepared.

The prepareToPlay() method is guaranteed to be called at least once on an 'unprepared' source to put it into a 'prepared' state before any calls will be made to getNextAudioBlock(). This callback allows the source to initialise any resources it might need when playing.

Once playback has finished, the releaseResources() method is called to put the stream back into an 'unprepared' state.

Note that this method could be called more than once in succession without a matching call to releaseResources(), so make sure your code is robust and can handle that kind of situation.

Parameters

  samplesPerBlockExpected | the number of samples that the source will be expected to supply each time its getNextAudioBlock() method is called. This number may vary slightly, because it will be dependent on audio hardware callbacks, and these aren't guaranteed to always use a constant block size, so the source should be able to cope with small variations.
  sampleRate | the sample rate that the output will be used at - this is needed by sources such as tone generators.

See also
  releaseResources, getNextAudioBlock

Implements juce::AudioSource.

Definition at line 46 of file juce_ResamplingAudioSource.cpp.

## releaseResources()

void juce::ResamplingAudioSource::releaseResources | ( |  | ) |

override virtual

Allows the source to release anything it no longer needs after playback has stopped.

This will be called when the source is no longer going to have its getNextAudioBlock() method called, so it should release any spare memory, etc. that it might have allocated during the prepareToPlay() call.

Note that there's no guarantee that prepareToPlay() will actually have been called before releaseResources(), and it may be called more than once in succession, so make sure your code is robust and doesn't make any assumptions about when it will be called.

See also
  prepareToPlay, getNextAudioBlock

Implements juce::AudioSource.

Definition at line 74 of file juce_ResamplingAudioSource.cpp.

## setResamplingRatio()

void juce::ResamplingAudioSource::setResamplingRatio | ( | double | samplesInPerOutputSample | ) |

Changes the resampling ratio.

(This value can be changed at any time, even while the source is running).

Parameters

  samplesInPerOutputSample | if set to 1.0, the input is passed through; higher values will speed it up; lower values will slow it down. The ratio must be greater than 0

Definition at line 38 of file juce_ResamplingAudioSource.cpp.

Referenced by juce::AudioTransportSource::setSource().

The documentation for this class was generated from the following files:

- juce_ResamplingAudioSource.h
- juce_ResamplingAudioSource.cpp